<template lang="pug">
component.field( :is='tag' :class='{ "not-expanded": !expanded }' )
	.label.is-flex.is-align-items-center( v-if='label || $slots.label || labelRight || $slots.labelRight' :class='{ "on-border is-small": onBorder }' )
		label( v-if='label || $slots.label' )
			slot( v-if='$slots.label' name="label" )
			template( v-else ) {{ label }}
		.label-right( v-if='labelRight || $slots.labelRight' )
			slot( v-if='$slots.labelRight' name="labelRight" )
			template( v-else ) {{ labelRight }}
	template( v-if='hasAddons' )
		.field.has-addons.nm
			.control( v-for='(component, i) in components' :key='i' )
				component( :is='component' )
	template( v-else )
		.control( :class='{ "is-expanded": expanded, "has-icons-left": !!iconLeft || !!$slots.iconLeft, "has-icons-right": !!iconRight || !!$slots.iconRight }' )
			slot
			template( v-if='iconLeft || $slots.iconLeft' )
				.icon.is-small.is-left
					slot( v-if='$slots.iconLeft' name="iconLeft" )
					i( v-else :class='[`fa-${packLeft}`, `fa-${iconLeft}`, ...iconBindClass]' )
			template( v-if='iconRight || $slots.iconRight' )
				.icon.is-small.is-right
					slot( v-if='$slots.iconRight' name="iconRight" )
					i( v-else :class='[`fa-${packRight}`, `fa-${iconRight}`, ...iconBindClass]' )
	p.help( v-if='message || $slots.message' :class='bindClass' )
		slot( v-if='$slots.message' name="message" )
		template( v-else ) {{ message }}
</template>

<script setup>
import { computed, useSlots } from "vue"

const slots = useSlots()
const components = computed(() => {
	if (!slots.default) return []

	let items = []

	for (let component of slots.default()) {
		if (typeof component.type == "symbol") {
			items.push( ...component.children )
		} else {
			items.push(component)
		}
	}

	return items
})

const props = defineProps({
	label: {
		type: String,
		default: ""
	},
	labelRight: {
		type: String,
		default: ""
	},
	onBorder: Boolean,
	expanded: {
		type: Boolean,
		default: true
	},
	type: {
		type: String,
		default: ""
	},
	message: {
		type: String,
		default: ""
	},
	hasAddons: Boolean,
	iconLeft: {
		type: String,
		default: ""
	},
	iconRight: {
		type: String,
		default: ""
	},
	packLeft: {
		type: String,
		default: "solid",
		validator: val => ["solid", "brands"].includes(val)
	},
	packRight: {
		type: String,
		default: "solid",
		validator: val => ["solid", "brands"].includes(val)
	},
	iconSize: {
		type: String,
		default: "",
		validator: val => ["", "xl", "lg", "2x"].includes(val)
	},
	tag: {
		type: String,
		default: "div",
		validator: val => ["div", "form"].includes(val)
	}
})

const bindClass = computed(() => [
	props.type ? `is-${props.type}` : ""
])

const iconBindClass = computed(() => [
	props.iconSize ? `fa-${props.iconSize}` : ""
])
</script>

<style lang="scss" scoped>
.field {
	position: relative;
	&.not-expanded {
		flex-grow: 0;
	}
	.control {
		.icon {
			pointer-events: all;
		}
	}
	.control {
		&.has-icons {
			&-right,
			&-left {
				&:deep(.tooltip) {
					width: 100%;
					height: 100%;
				}
			}
		}
	}
	.has-addons {
		z-index: 0;
	}
}

.label.on-border {
	font-size: .75rem;
	line-height: .75rem;
	position: absolute;
	top: calc(.75rem / -2);
	left: .5rem;
	z-index: 1;
	background: #fff;
}
.label-right {
	font-size: .875rem;
	font-weight: 500;
	color: $grey;
	margin-left: auto;
}

.control:deep(.button) {
	height: calc(100% - 1px);
	&.is-small {
		height: 100%;
	}
}
</style>